import { defineComponent as ee, ref as d, onMounted as $, withDirectives as te, createVNode as o, mergeProps as V, resolveComponent as w, resolveDirective as ae, nextTick as J, isVNode as le, toRef as G, Fragment as ie } from "vue";
import ne from "qs";
import "../../selectArea/index.js";
import "../../selectDate/index.js";
import "../../selectTime/index.js";
import "../../trend/index.js";
import "../../progress/index.js";
import "../../notification/index.js";
import "../index.js";
import { KCustomElement as K } from "../../customElement/index.js";
import "../../form/index.js";
import { tableProps as ue, tableEmits as oe } from "./props.js";
import { Check as re, Close as de, Edit as ce } from "@element-plus/icons-vue";
import { createNamespacs as me, getValue as A } from "@tomiaa/utils";
import "../../packages/theme-chalk/lib/vue3-components/table.js";
function se(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !le(e);
}
const y = me("table"), Le = ee({
  name: "KTable",
  props: ue,
  emits: oe,
  setup(e, {
    attrs: D,
    slots: k,
    emit: m,
    expose: H
  }) {
    const L = d(""), N = d(""), {
      append: _,
      empty: B = () => e.emptyTip && T.value && L.value,
      page: W,
      editControlIcon: R,
      editIcon: Q
    } = k, v = d({}), h = d({}), X = (c) => c == null ? void 0 : c.map((x) => {
      const {
        slot: z,
        action: E,
        actionConfig: l,
        editable: f,
        editableConfig: u,
        ...S
      } = x, s = {
        header: k.header,
        default: z && k[z]
      };
      if (e.editRow && (s.default = (t) => {
        const {
          row: a,
          column: i,
          $index: r
        } = t;
        return o("div", {
          class: [y.e("editable"), y.is("editable", v.value[r])]
        }, [v.value[r] ? o(w("el-input"), {
          size: "small",
          modelValue: h.value[r][i.property],
          "onUpdate:modelValue": (g) => h.value[r][i.property] = g
        }, null) : a[i.property]]);
      }), (E || l) && (s.default = (t) => {
        const {
          $index: a,
          row: i
        } = t;
        let r = [{
          el: "el-button",
          size: "small",
          "v-if": l == null ? void 0 : l.showEdit,
          onClick: () => {
            if (e.editRow) {
              if (v.value[a]) {
                Object.assign(t.row, h.value[a]), delete h.value[a], delete v.value[a], m("confirmEditRow", t);
                return;
              }
              h.value[a] = JSON.parse(JSON.stringify(i)), v.value[a] = !0;
            }
            m("edit", t);
          },
          children: v.value[a] ? "\u786E\u5B9A" : (l == null ? void 0 : l.editText) || "\u7F16\u8F91"
        }, {
          el: "el-button",
          size: "small",
          type: "danger",
          "v-if": l == null ? void 0 : l.showDelete,
          onClick: () => {
            if (e.editRow) {
              delete h.value[a], delete v.value[a], m("cancelEditRow", t);
              return;
            }
            m("delete", t);
          },
          children: v.value[a] ? "\u53D6\u6D88" : (l == null ? void 0 : l.deleteText) || "\u5220\u9664"
        }];
        return l != null && l.custom && (r = l.custom(r, t)), o(K, {
          list: r
        }, null);
      }), f || u) {
        const t = d({}), a = d({});
        s.default = (i) => {
          const {
            row: r,
            column: g,
            $index: Z
          } = i, n = g.id + Z, M = () => {
            delete a.value[n], delete t.value[n];
          };
          let O = [{
            el: "el-icon",
            color: "var(--el-color-success)",
            size: "1.2em",
            "v-if": u == null ? void 0 : u.showEnter,
            onClick() {
              r[g.property] = a.value[n], M(), m("confirmEditCell", i);
            },
            children: re
          }, {
            el: "el-icon",
            size: "1.2em",
            color: "var(--el-color-danger)",
            "v-if": u == null ? void 0 : u.showClose,
            onClick() {
              M(), m("cancelEditCell", i);
            },
            children: de
          }];
          return u != null && u.custom && (O = u.custom(O, i, G(t.value, n))), o("div", {
            class: [y.e("editable"), y.is("editable", t.value[n])]
          }, [t.value[n] ? o(w("el-input"), {
            size: "small",
            modelValue: a.value[n],
            "onUpdate:modelValue": (p) => a.value[n] = p
          }, null) : r[g.property], t.value[n] ? o(ie, null, [
            (R == null ? void 0 : R({
              ...i,
              isEdit: G(t.value, n)
            })) || o(K, {
              list: O
            }, null)
          ]) : Q ? o("span", {
            onClick: () => {
              a.value[n] = r[g.property];
            }
          }, [Q({
            ...i,
            isEdit: G(t.value, n)
          })]) : o(w("el-icon"), {
            size: "1.2em",
            onClick: () => {
              a.value[n] = r[g.property], t.value[n] = !t.value[n];
            }
          }, {
            default: () => [o(ce, null, null)]
          })]);
        };
      }
      return o(w("el-table-column"), S, se(s) ? s : {
        default: () => [s]
      });
    }), Y = () => o(w("el-pagination"), V({
      class: y.b("pagination"),
      defaultCurrentPage: e.defaultCurrentPage,
      defaultPageSize: e.defaultPageSize,
      currentPage: q.value,
      pageSize: F.value,
      total: I.value,
      ref: P,
      layout: "->,sizes,prev,pager,next,jumper,total",
      "hide-on-single-page": !0
    }, D, {
      "onUpdate:currentPage": async (c) => {
        q.value = c, await J(), b();
      },
      "onUpdate:page-size": async (c) => {
        F.value = c, await J(), b();
      }
    }), {
      default: W
    }), P = d(), U = d(), C = d(null), I = d(0), q = d(e.defaultCurrentPage || 1), F = d(e.defaultPageSize || 10), T = d(!1), b = () => {
      var u, S, s;
      T.value = !0, C.value = null;
      let c;
      e.emptyTip && (L.value = e.emptyTip, clearTimeout(c), c = setTimeout(() => {
        L.value = e.emptyTipTimeoutText;
      }, e.emptyTipTimeout));
      let x;
      e.elLoadingTextTimeoutText && (N.value = e.elementLoadingText, clearTimeout(x), setTimeout(() => {
        const t = document.querySelector(".el-loading-text");
        t && (t.innerHTML = e.elLoadingTextTimeoutText);
      }, e.elLoadingTextTimeout));
      const z = e.server, E = {
        [((u = e.replaceFields) == null ? void 0 : u.pageSize) || "pageSize"]: P.value.pageSize,
        [((S = e.replaceFields) == null ? void 0 : S.currentPage) || "currentPage"]: P.value.currentPage
      }, l = {};
      if (e.withDataPath !== !1) {
        const t = {
          get: "params",
          post: "data"
        }, a = e.withDataPath || t[(((s = e.getConfig) == null ? void 0 : s.method) || "get").toLocaleLowerCase()];
        a && (l[a] = {});
        const i = l[a] || l;
        Object.assign(i, e.withPagePath && typeof e.withPagePath == "string" ? {
          [e.withPagePath]: E
        } : E), Object.assign(i, e.withQueryPath && typeof e.withQueryPath == "string" ? {
          [e.withQueryPath]: e.withQuery
        } : e.withQuery);
      }
      const f = {
        url: e.getUrl,
        ...l,
        ...e.getConfig
      };
      e.stringify && f.data && (f.data = ne.stringify(f.data)), m("beforeGetData", f), z(f).then((t) => {
        m("afterGetData", t), C.value = A(e.dataPath, t), I.value = A(e.totalPath, t);
      }).catch((t) => {
        m("failToGetData", t);
      }).finally(() => {
        clearTimeout(c), clearTimeout(x), T.value = !1;
      });
    };
    e.showPagination && $(b);
    const j = {
      getData: b
    };
    return $(() => {
      j.elPagination = P.value, j.elTable = U.value;
    }), H(j), () => te(o("div", V({
      class: y.b(),
      "element-loading-text": N.value
    }, D), [o(w("el-table"), V({
      data: C.value,
      ref: U
    }, D), {
      default: () => [X(e.options)],
      append: _,
      empty: B
    }), e.showPagination && Y(), e.showLoadInGet && T.value]), [[ae("loading"), e.showLoadInGet && T.value]]);
  }
});
export {
  Le as default
};
